

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by cteam006 on 10/22/16.
 */
public class Display {

    static Integer N = null;

    static char table[][] = {
            {'v', '^', '<', '>', 'o', 'x', '-', '|', '\\', '/'},
            {'^', 'v', '>', '<', 'o', 'x', '-', '|', '\\', '/'},
            {'<', '>', 'v', '^', 'o', 'x', '|', '-','\\', '/'},
            {'>', '<', '^', 'v', 'o', 'x', '|', '-','\\', '/'},
            {'^', 'v', '<', '>', 'o', 'x', '-', '|', '/', '\\'},
            {'v', '^', '>', '<', 'o', 'x', '-', '|', '/', '\\'}
    };

    static Map<Character, Integer> map = new HashMap<>();

    char[][] matrix = null;
    char[][] matrix_res = null;


    public static void main(String[] args) throws IOException {


        Display d = new Display();
        d.perform();


    }


    public void perform() throws IOException {

        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        Scanner sc = new Scanner(System.in);

        map.put('<', 0);
        map.put('>', 1);
        map.put('^', 2);
        map.put('v', 3);
        map.put('o', 4);
        map.put('x', 5);
        map.put('|', 6);
        map.put('-', 7);
        map.put('/', 8);
        map.put('\\', 9);








        N = Integer.parseInt(br.readLine());

        System.out.println("N" + N);
        matrix = new char[N][N];
        matrix_res = new char[N][N];

        for(int i = 0; i < N; i++){
            String line = br.readLine();

            for (int j = 0; j < N; j++){

                matrix[i][j] = line.charAt(j);



            }
        }

        String program = br.readLine();

        doTHIS(program);




        for(int i = 0; i < N; i++){
            for(int j = 0; j < N; j++){
                System.out.print(matrix_res[i][j]);
            }
            System.out.println();
        }
    }


    public void doTHIS(String line){
        Point p = null;

        for(int i = 0; i < N; i++){
            for(int j = 0; j < N; j++){
                p = new Point(i, j, matrix[i][j]);
                for(int k = 0; k < line.length(); k++){

                    char c = line.charAt(k);

                    if(c == ' '){
                        continue;
                    }

                    if(c == '<'){

                        p = rotateLeft(p);

                        matrix_res[p.x][p.y] = p.c;
                    }

                    if(c == '>'){
                        //p = new Point(i, j, matrix[i][j]);
                        p = rotateRight(p);

                        matrix_res[p.x][p.y] = p.c;
                    }

                    if(c == '-'){
                        //p = new Point(i, j, matrix[i][j]);
                        p = cherto4ka(p);

                        matrix_res[p.x][p.y] = p.c;
                    }

                    if(c == '|'){
                        //p = new Point(i, j, matrix[i][j]);
                        p = polosochka(p);

                        matrix_res[p.x][p.y] = p.c;
                    }

                    if(c == '\\'){
                        //p = new Point(i, j, matrix[i][j]);
                        p = slashobrat(p);

                        matrix_res[p.x][p.y] = p.c;
                    }

                    if(c == '/'){
                        //p = new Point(i, j, matrix[i][j]);
                        p = slash(p);

                        matrix_res[p.x][p.y] = p.c;
                    }

                }


            }
        }
    }





    public Point rotateLeft(Point p) {
        int functionid = 0;
        int tmp = p.x;
        p.x = N -1 - p.y;
        p.y = tmp;
        p.c = table[0][map.get(p.c)];
        return p;
    }

    public Point rotateRight(Point p) {
        int functionid = 1;
        int tmp = p.x;
        p.x = p.y;
        p.y = N -1 - tmp;
        p.c = table[1][map.get(p.c)];
        return p;
    }

    public Point cherto4ka(Point p) {
        int functionid = 2;
        p.x = N -1 - p.x;
        p.y = p.y;
        p.c = table[2][map.get(p.c)];
        return p;
    }

    public Point polosochka(Point p) {
        int functionid = 3;
        int tmp = p.x;
        p.x = p.x;
        p.y = N -1 - p.y;
        p.c = table[3][map.get(p.c)];
        return p;
    }

    public Point slashobrat(Point p) {
        int functionid = 4;
        int tmp = p.x;
        p.x = p.y;
        p.y = tmp;
        p.c = table[4][map.get(p.c)];
        return p;
    }

    public Point slash(Point p) {
        int functionid = 0;
        int tmp = p.x;
        p.x = N -1 - p.y;
        p.y = N -1 - tmp;
        p.c = table[5][map.get(p.c)];
        return p;
    }



    public class Point {
        int x;
        int y;
        char c;

        public Point(int x, int y, char c){
            this.x = x;
            this.y = y;
            this.c = c;
        }
    }
}
